{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R+,S+,T-,V+,X+}
{$M 16384,0,655360}
{ $DEFINE debug}
unit Infrared;

interface

uses
 Dos,Crt;


const
  PortLPT:Word=$378;               {Address of LPT port}
  UseKeybRemoteCodes:Boolean=True; {Allow advanced Keyboard remote (20 bit) codes}
  CommandDelay:Word=65;            {Delay between 2 commands [ms]}
  StopDelay:Word=0;                {Added delay after Stop command [ms]}
  SelectTrackDelay:Word=0;         {Added delay after SelectTrack [ms]}
  SetNameModeDelay:Word=250;       {Added delay after Name command [ms]}
  ReSetNameModeDelay:Word=0;       {Added delay after exiting Name mode [ms]}
  ChangeTitleModeDelay:Word=860;   {Added delay after change title mode (Numeric,LowerCase,UpperCase) [ms]}

type
  tIRCodeString=String[25];

const
 ir_SonyMD_postfix     = '11110';
 ir_SonyKeybMD_postfix = '101110000110';   {MD remote keyboard RM-D10P}
 ir_SonyCD_postfix     = '10001';
 ir_SonyAMP_postfix    = '00110';
 ir_SonyCTRL_postfix   = '00001';
 ir_SonyTuner_postfix  = '10110';

 ir_SonyMD_1       = '0000000' + ir_SonyMD_postfix;    {1, F}
 ir_SonyMD_2       = '1000000' + ir_SonyMD_postfix;    {2, G}
 ir_SonyMD_3       = '0100000' + ir_SonyMD_postfix;    {3, H}
 ir_SonyMD_4       = '1100000' + ir_SonyMD_postfix;    {4, I}
 ir_SonyMD_5       = '0010000' + ir_SonyMD_postfix;    {5, J}
 ir_SonyMD_6       = '1010000' + ir_SonyMD_postfix;    {6, K}
 ir_SonyMD_7       = '0110000' + ir_SonyMD_postfix;    {7, L}
 ir_SonyMD_8       = '1110000' + ir_SonyMD_postfix;    {8, M}
 ir_SonyMD_9       = '0001000' + ir_SonyMD_postfix;    {9, N}
 ir_SonyMD_10      = '1001000' + ir_SonyMD_postfix;    {0, O}
 ir_SonyMD_More25  = '0101000' + ir_SonyMD_postfix;    {/}
 ir_SonyMD_Clear   = '1111000' + ir_SonyMD_postfix;    {Del}
 ir_SonyMD_Power   = '1010100' + ir_SonyMD_postfix;
 ir_SonyMD_Eject   = '0110100' + ir_SonyMD_postfix;
 ir_SonyMD_Display = '0001100' + ir_SonyMD_postfix;
 ir_SonyMD_Scroll  = '1001100' + ir_SonyMD_postfix;
 ir_SonyMD_DPre    = '1101100' + ir_SonyMD_postfix;    {D}
 ir_SonyMD_DRec    = '0101100' + ir_SonyMD_postfix;    {E}
 ir_SonyMD_ContPlay= '1011100' + ir_SonyMD_postfix;    {A}
 ir_SonyMD_Shuffle = '0111100' + ir_SonyMD_postfix;    {B}
 ir_SonyMD_Program = '1111100' + ir_SonyMD_postfix;    {C}
 ir_SonyMD_TrRev   = '0000010' + ir_SonyMD_postfix;
 ir_SonyMD_TrForw  = '1000010' + ir_SonyMD_postfix;
 ir_SonyMD_Repeat  = '0110010' + ir_SonyMD_postfix;    {?}
 ir_SonyMD_ABRepeat= '1110010' + ir_SonyMD_postfix;    {!}
 ir_SonyMD_Stop    = '0001010' + ir_SonyMD_postfix;
 ir_SonyMD_Pause   = '1001010' + ir_SonyMD_postfix;
 ir_SonyMD_Play    = '0101010' + ir_SonyMD_postfix;
 ir_SonyMD_ScanBack= '1101010' + ir_SonyMD_postfix;    {cursor back}
 ir_SonyMD_ScanForw= '0011010' + ir_SonyMD_postfix;    {cursor forw}
 ir_SonyMD_Rocord  = '1011010' + ir_SonyMD_postfix;
 ir_SonyMD_TRec    = '0000110' + ir_SonyMD_postfix;
 ir_SonyMD_ASpace  = '1100110' + ir_SonyMD_postfix;    {(}
 ir_SonyMD_MScan   = '0010110' + ir_SonyMD_postfix;    {)}
 ir_SonyMD_Char    = '0110110' + ir_SonyMD_postfix;
 ir_SonyMD_Num     = '1110110' + ir_SonyMD_postfix;
{ir_SonyMD_Clear   = '0101110' + ir_SonyMD_postfix;}
 ir_SonyMD_Name    = '0011110' + ir_SonyMD_postfix;
{ir_SonyMD_Clear   = '1011110' + ir_SonyMD_postfix;}
 ir_SonyMD_MusicSyn= '1111110' + ir_SonyMD_postfix;
 ir_SonyMD_11      = '0000001' + ir_SonyMD_postfix;    {P}
 ir_SonyMD_12      = '1000001' + ir_SonyMD_postfix;    {Q}
 ir_SonyMD_13      = '0100001' + ir_SonyMD_postfix;    {R}
 ir_SonyMD_14      = '1100001' + ir_SonyMD_postfix;    {S}
 ir_SonyMD_15      = '0010001' + ir_SonyMD_postfix;    {T}
 ir_SonyMD_16      = '1010001' + ir_SonyMD_postfix;    {U}
 ir_SonyMD_17      = '0110001' + ir_SonyMD_postfix;    {V}
 ir_SonyMD_18      = '1110001' + ir_SonyMD_postfix;    {W}
 ir_SonyMD_19      = '0001001' + ir_SonyMD_postfix;    {X}
 ir_SonyMD_20      = '1001001' + ir_SonyMD_postfix;    {Y}
 ir_SonyMD_21      = '0101001' + ir_SonyMD_postfix;    {Z}
 ir_SonyMD_22      = '1101001' + ir_SonyMD_postfix;    {-}
 ir_SonyMD_23      = '0011001' + ir_SonyMD_postfix;    {space}
 ir_SonyMD_24      = '1011001' + ir_SonyMD_postfix;    {.}
 ir_SonyMD_25      = '0111001' + ir_SonyMD_postfix;    {'}

 ir_SonyCD_program = '1111100' + ir_SonyCD_postfix;
 ir_SonyCD_shuffle = '1010110' + ir_SonyCD_postfix;
 ir_SonyCD_continue= '1011100' + ir_SonyCD_postfix;
 ir_SonyCD_time    = '0001010' + ir_SonyCD_postfix;
 ir_SonyCD_repeat  = '0011010' + ir_SonyCD_postfix;
 ir_SonyCD_disk1   = '0000001' + ir_SonyCD_postfix;
 ir_SonyCD_disk2   = '1000001' + ir_SonyCD_postfix;
 ir_SonyCD_disk3   = '0100001' + ir_SonyCD_postfix;
 ir_SonyCD_disk4   = '1100001' + ir_SonyCD_postfix;
 ir_SonyCD_disk5   = '0010001' + ir_SonyCD_postfix;
 ir_SonyCD_diskskip= '0111110' + ir_SonyCD_postfix;
 ir_SonyCD_play    = '0100110' + ir_SonyCD_postfix;
 ir_SonyCD_fade    = '1111101' + ir_SonyCD_postfix;
 ir_SonyCD_pause   = '1001110' + ir_SonyCD_postfix;
 ir_SonyCD_prev    = '0000110' + ir_SonyCD_postfix;
 ir_SonyCD_next    = '1000110' + ir_SonyCD_postfix;
 ir_SonyCD_stop    = '0001110' + ir_SonyCD_postfix;
 ir_SonyCD_reverse = '1100110' + ir_SonyCD_postfix;
 ir_SonyCD_forward = '0010110' + ir_SonyCD_postfix;

 ir_SonyAMP_volumeUp   = '0100100' + ir_SonyCTRL_postfix;
 ir_SonyAMP_volumeDown = '1100100' + ir_SonyCTRL_postfix;
 ir_SonyAMP_mute       = '0010100' + ir_SonyCTRL_postfix;
 ir_SonyAMP_lowboost   = '1000110' + ir_SonyAMP_postfix;
 ir_SonyAMP_surMode    = '0110001' + ir_SonyAMP_postfix;
 ir_SonyAMP_surOnOff   = '1111110' + ir_SonyAMP_postfix;

 ir_SonyTuner_1        = '0000000' + ir_SonyTuner_postfix;
 ir_SonyTuner_2        = '1000000' + ir_SonyTuner_postfix;
 ir_SonyTuner_3        = '0100000' + ir_SonyTuner_postfix;
 ir_SonyTuner_4        = '1100000' + ir_SonyTuner_postfix;
 ir_SonyTuner_5        = '0010000' + ir_SonyTuner_postfix;
 ir_SonyTuner_6        = '1010000' + ir_SonyTuner_postfix;
 ir_SonyTuner_7        = '0110000' + ir_SonyTuner_postfix;
 ir_SonyTuner_8        = '1110000' + ir_SonyTuner_postfix;
 ir_SonyTuner_9        = '0001000' + ir_SonyTuner_postfix;
 ir_SonyTuner_0        = '1001000' + ir_SonyTuner_postfix;

procedure SendCode(S:String);

implementation

var
 lastcode:string;

procedure data; assembler;
asm
 dd 0        { +0 addr of byte in buffer }
 dw 0        { +4 counter }
 dw 0        { +6 addr. of LPT port}
end;

procedure NewInt8; assembler;
asm
 sti
 push   ax
 mov    ax,word ptr cs:[data+4]     { change counter }
 and    ax,ax
 jne    @pokracuj      { if 0 then do nothing }
 push   dx             { else clear the port }
 mov    dx,word ptr cs:[data+6]
 xor    al,al
 out    dx,al
 pop    dx
 jmp    @eoi

@pokracuj:
 dec    ax
 mov    word ptr cs:[data+4],ax

 {read Byte to send}
 push    ds
 push    si
 push    dx
 lds     si,dword ptr cs:[data]  { addr. of Byte }
 mov     al,ds:[si]              { Value}
 inc     si
 mov     word ptr cs:[data],si   { store new address }
 mov     dx,word ptr cs:[data+6]
 out     dx,al                   { send Byte to port }
 mov     si,$B800
 mov     ds,si
 mov     ds:[0],al
 mov     al,40h
 mov     ds:[1],al
 pop     dx
 pop     si
 pop     ds

@eoi:
 mov    al,20h
 out    20h,al
 pop    ax
 iret
end;

{ with int }
procedure SendBuffer_2(var buffer; size:Word);
const
 DIVISOR:Word = 716;
 MINIDELAY:Word = 1223;
var
 old8:Pointer;
 i:integer;
 zerobuf:array [1..10] of Byte;
begin
 if size = 0 then
  Exit;
 FillChar(zerobuf,sizeof(zerobuf),0);
 { set counter to 0, => stop interrupt service }
 MemW[CSeg:Ofs(data)+4]:=0;
 MemW[CSeg:Ofs(data)+6]:=PortLpt;
 GetIntVec(8,old8);
 SetIntVec(8,@NewInt8);
 { faster timer }
 asm
  cli
  mov   al,36h
  out   43h,al
  nop
  jmp   @1
 @1:
  mov   ax,[DIVISOR]
  out   40h,al
  nop
  jmp   @2
 @2:
  mov   al,ah
  out   40h,al
  sti
 end;

 { start int. service }
 Pointer(MemL[CSeg:Ofs(data)]):=@buffer;
 MemW[CSeg:Ofs(data)+4]:=size;
 { wait until service stopped }
 while MemW[CSeg:Ofs(data)+4] <> 0 do;

 { normal timer }
 asm
  cli
  mov   al,36h
  out   43h,al
  nop
  jmp   @1
 @1:
  xor   al,al
  out   40h,al
  nop
  jmp   @2
 @2:
  xor   al,al
  out   40h,al
  sti
 end;
 SetIntVec(8,old8);
end;

procedure SendCode(S:String);
type
 tbuf=array [1..30000] of Byte;
 pbuf=^tbuf;
var
 i,j,cnt:integer;
 buf:pbuf;
begin
 New(buf);
 j:=1;
 for cnt:=1 to 3 do { send every code 3 times, with pause cca 43,5 zeros }
  begin
   buf^[j]:=$FF;
   buf^[j+1]:=$FF;
   buf^[j+2]:=$FF;
   buf^[j+3]:=$FF;
   buf^[j+4]:=0;
   j:=j+5;
   for i:=1 to Length(S) do
    if S[i] = '0' then
     begin
      buf^[j]:=$FF;
      buf^[j+1]:=0;
      j:=j+2;
     end
    else
     begin
      buf^[j]:=$FF;
      buf^[j+1]:=$FF;
      buf^[j+2]:=0;
      j:=j+3;
     end;
   { and there is 43,5 zeros }
   for i:=1 to 43 do
    begin
     buf^[j]:=0;
     j:=j+1
    end;
  end;
 dec(j);
 if LastCode = '' then
  LastCode:=S;
 if LastCode <> S then
  Delay(CommandDelay) { new command }
 else
  Delay(CommandDelay);
 LastCode:=S;
{$IFDEF debug}
 Writeln('Sending Code ',S);
{$ENDIF}
 SendBuffer_2(buf^,j);
 Dispose(buf);
end;

begin
 lastcode:='';
end.